local bs = AceLibrary("Babble-Spell-2.2")
local AceAddon = AceLibrary("AceAddon-2.0")
local Tablet = AceLibrary("Tablet-2.0")
local Deformat = AceLibrary("Deformat-2.0")
local Talismonger = AceLibrary("Talismonger-3.0")

local L = AceLibrary("AceLocale-2.2"):new("Cartographer_Herbalism")
L:RegisterTranslations("enUS", function() return {
	["Filter"] = true,
	["Filter out herbs"] = true,
  
  ["Module description"]  = "Herbalism mapnotes for Cartographer (based on PinPoint by Ammo)",
	
	["Select all"] = true,
	["Select none"] = true,
	["Icon alpha"] = true,
	["Alpha transparency of the icon"] = true,
	["Icon size"] = true,
	["Size of the icons on the map"] = true,
	["Show minimap icons"] = true,
	["Show herbalism icons on the minimap"] = true,
	
	-- herbs
	["Silverleaf"] = true,
	["Peacebloom"] = true,
	["Mageroyal"] = true,
	["Bruiseweed"] = true,
	["Kingsblood"] = true,
	["Fadeleaf"] = true,
	["Stranglekelp"] = true,
	["Liferoot"] = true,
	["Briarthorn"] = true,
	["Earthroot"] = true,
	["Sungrass"] = true,
	["Blindweed"] = true,
	["Gromsblood"] = true,
	["Dreamfoil"] = true,
	["Firebloom"] = true,
	["Arthas' Tears"] = true,
	["Purple Lotus"] = true,
	["Goldthorn"] = true,
	["Wildvine"] = true,
	["Grave Moss"] = true,
	["Mountain Silversage"] = true,
	["Black Lotus"] = true,
	["Ghost Mushroom"] = true,
	["Golden Sansam"] = true,
	["Icecap"] = true,
	["Khadgar's Whisker"] = true,
	["Plaguebloom"] = true,
	["Swiftthistle"] = true,
	["Wild Steelbloom"] = true,
	["Wintersbite"] = true,
	-- tbc
	["Felweed"] = true,
	["Bloodthistle"] = true,
	["Mana Thistle"] = true,
	["Netherbloom"] = true,
	["Nightmare Vine"] = true,
	["Ragveil"] = true,
	["Terocone"] = true,
	["Flame Cap"] = true,
	["Dreaming Glory"] = true,
	["Fel Lotus"] = true,
	["Ancient Lichen"] = true,
} end)

L:RegisterTranslations("deDE", function() return {
	["Filter"] = "Filter",
	["Filter out herbs"] = "Kr\195\164uter filtern",
	
  ["Module description"]  = "Kr\195\164uterkunde-Kartennotizen f\195\188r Cartographer (basiert auf PinPoint von Ammo)",  

	["Select all"] = "Alle ausw\195\164hlen",
	["Select none"] = "Nichts ausw\195\164hlen",
	["Icon alpha"] = "Transparenz",
	["Alpha transparency of the icon"] = "Transparenz der Symbole",
	["Icon size"] = "Symbolgr\195\182\195\159e",
	["Size of the icons on the map"] = "Gr\195\182\195\159e der Symbole auf der Weltkarte",
	["Show minimap icons"] = "Minimap-Symbole anzeigen",
	["Show herbalism icons on the minimap"] = "Kr\195\164utersymbole auf der Minimap anzeigen.",
  
	-- herbs
	["Silverleaf"] = "Silberblatt",
	["Peacebloom"] = "Friedensblume",
	["Mageroyal"] = "Magusk\195\182nigskraut", 
	["Bruiseweed"] = "Beulengras", 
	["Kingsblood"] = "K\195\182nigsblut",
	["Fadeleaf"] = "Blassblatt",
	["Stranglekelp"] = "W\195\188rgetang",
	["Liferoot"] = "Lebenswurz",
	["Briarthorn"] = "Wilddornrose", 
	["Earthroot"] = "Erdwurzel",
	["Sungrass"] = "Sonnengras",
	["Blindweed"] = "Blindkraut", 
	["Gromsblood"] = "Gromsblut",
	["Dreamfoil"] = "Traumblatt",
	["Firebloom"] = "Feuerbl\195\188te",
	["Arthas' Tears"] = "Arthas\226\128\153 Tr\195\164nen",
	["Purple Lotus"] = "Lila Lotus",
	["Goldthorn"] = "Golddorn",
	["Wildvine"] = "Wildranke",
	["Grave Moss"] = "Grabmoos",
	["Mountain Silversage"] = "Bergsilberweisling",
	["Black Lotus"] = "Schwarzer Lotus",
	["Ghost Mushroom"] = "Geisterpilz",
	["Golden Sansam"] = "Goldener Sansam",
	["Icecap"] = "Eiskappe",
	["Khadgar's Whisker"] = "Khadgars Schnurrbart",
	["Plaguebloom"] = "Pestbl\195\188te",
	["Swiftthistle"] = "Flitzdistel",
	["Wild Steelbloom"] = "Wildstahlblume",
	["Wintersbite"] = "Winterbiss",
	-- tbc
	["Felweed"] = "Teufelsgras",
	["Bloodthistle"] = "Blutdistel",
	["Mana Thistle"] = "Manadistel",
	["Netherbloom"] = "Netherbl\195\188te",
	["Nightmare Vine"] = "Alptraumranke",
	["Ragveil"] = "Zottelkappe",
	["Terocone"] = "Terozapfen",
	["Flame Cap"] = "Flammenkappe",
	["Dreaming Glory"] = "Traumwinde",
	["Fel Lotus"] = "Teufelslotus",
	["Ancient Lichen"] = "Urflechte",
} end)

L:RegisterTranslations("frFR", function() return {
	["Filter"] = "Filtrer",
	["Filter out herbs"] = "Filtrer les plantes",

	["Module description"]  = "Notes d'herboristerie pour Cartographer (bas\195\169 sur PinPoint par Ammo)",

	["Select all"] = "Tout S\195\169lectionner",
	["Select none"] = "Ne rien S\195\169lectionner",
	["Icon alpha"] = "Transparence des ic\195\180nes",
	["Alpha transparency of the icon"] = "D\195\169termine la transparence des ic\195\180nes.",
	["Icon size"] = "Taille des ic\195\180nes",
	["Size of the icons on the map"] = "D\195\169termine la taille des ic\195\180nes sur la carte.",
	["Show minimap icons"] = "Afficher les ic\195\180nes sur la minicarte",
	["Show herbalism icons on the minimap"] = "Affiche les ic\195\180nes des herbes sur la minicarte.",

	-- herbs
	["Silverleaf"] = "Feuillargent",
	["Peacebloom"] = "Pacifique",
	["Mageroyal"] = "Mage royal",
	["Bruiseweed"] = "Doulourante",
	["Kingsblood"] = "Sang-royal",
	["Fadeleaf"] = "P\195\162lerette",
	["Stranglekelp"] = "Etouffante",
	["Liferoot"] = "Viet\195\169rule",
	["Briarthorn"] = "Eglantine",
	["Earthroot"] = "Terrestrine",
	["Sungrass"] = "Soleillette",
	["Blindweed"] = "Aveuglette",
	["Gromsblood"] = "Gromsang",
	["Dreamfoil"] = "Feuiller\195\170ve",
	["Firebloom"] = "Fleur de feu",
	["Arthas' Tears"] = "Larmes d'Arthas",
	["Purple Lotus"] = "Lotus pourpre",
	["Goldthorn"] = "Dor\195\169pine",
	["Wildvine"] = "Sauvageonne",
	["Grave Moss"] = "Tombeline",
	["Mountain Silversage"] = "Sauge-argent des montagnes",
	["Black Lotus"] = "Lotus noir",
	["Ghost Mushroom"] = "Champignon fant\195\180me",
	["Golden Sansam"] = "Sansam dor\195\169",
	["Icecap"] = "Calot de glace",
	["Khadgar's Whisker"] = "Moustache de Khadgar",
	["Plaguebloom"] = "Fleur de peste",
	["Swiftthistle"] = "Chardonnier",
	["Wild Steelbloom"] = "Aci\195\169rite sauvage",
	["Wintersbite"] = "Hivernale",
	-- tbc
	["Felweed"] = "Gangrelette",
	["Bloodthistle"] = "Chardon sanglant",
	["Mana Thistle"] = "Chardon de mana",
	["Netherbloom"] = "N\195\169antine",
	["Nightmare Vine"] = "Cauchemardelle",
	["Ragveil"] = "Voile-mis\195\168re",
	["Terocone"] = "Terroc\195\180ne",
	["Flame Cap"] = "Chapeflamme",
	["Dreaming Glory"] = "Glaurier",
	["Fel Lotus"] = "Gangrelotus",
	["Ancient Lichen"] = "Lichen ancien",
} end)

L:RegisterTranslations("koKR", function() return {
	["Filter"] = "필터링",
	["Filter out herbs"] = "약초에 따라서 지도에 표시 여부를 선택합니다",

  ["Module description"] = "맵노트에 약초를 표시합니다.",

	["Select all"] = "모두 선택",
	["Select none"] = "선택 해제",
	["Icon alpha"] = "아이콘 투명도",
	["Alpha transparency of the icon"] = "아이콘의 투명도를 조절합니다.",
	["Icon size"] = "아이콘 크기",
	["Size of the icons on the map"] = "아이콘의 크기를 조절합니다.",
	["Show minimap icons"] = "미니맵 아이콘 보기",
	["Show herbalism icons on the minimap"] = "미니맵에 약초 아이콘을 표시합니다.",

	-- herbs
	["Silverleaf"] = "은엽수 덤불",
	["Peacebloom"] = "평온초",
	["Mageroyal"] = "마법초",
	["Bruiseweed"] = "생채기풀",
	["Kingsblood"] = "왕꽃잎풀",
	["Fadeleaf"] = "미명초",
	["Stranglekelp"] = "갈래물풀",
	["Liferoot"] = "생명의 뿌리",
	["Briarthorn"] = "찔레가시",
	["Earthroot"] = "뱀뿌리",
	["Sungrass"] = "태양풀",
	["Blindweed"] = "실명초",
	["Gromsblood"] = "그롬의 피",
	["Dreamfoil"] = "꿈풀",
	["Firebloom"] = "화염초",
	["Arthas' Tears"] = "아서스의 눈물",
	["Purple Lotus"] = "보라 연꽃",
	["Goldthorn"] = "황금가시",
	["Wildvine"] = "야생덩굴",
	["Grave Moss"] = "무덤이끼",
	["Mountain Silversage"] = "은초롱이",
	["Black Lotus"] = "검은 연꽃",
	["Ghost Mushroom"] = "유령버섯",
	["Golden Sansam"] = "황금 산삼",
	["Icecap"] = "얼음송이",
	["Khadgar's Whisker"] = "카드가의 수염",
	["Plaguebloom"] = "역병초",
	["Swiftthistle"] = "토끼엉겅퀴풀",
	["Wild Steelbloom"] = "야생 철쭉",
	["Wintersbite"] = "겨울서리풀",
  -- tbc
	["Felweed"] = "지옥풀",
	["Bloodthistle"] = "피 엉겅퀴",
	["Mana Thistle"] = "마나 엉겅퀴",
	["Netherbloom"] = "황천꽃", --check
	["Nightmare Vine"] = "악몽의 덩굴",
	["Ragveil"] = "가림막이버섯", --check
	["Terocone"] = "테로열매",
	["Flame Cap"] = "불꽃송이", --check
	["Dreaming Glory"] = "꿈초롱이",
	["Fel Lotus"] = "지옥 연꽃", --check
	["Ancient Lichen"] = "고대 이끼",
} end)

L:RegisterTranslations("zhTW", function() return {
	["Filter"] = "篩檢",
	["Filter out herbs"] = "篩檢草藥",
	
	["Select all"] = "全部選擇",
	["Select none"] = "全部取消",

	-- herbs
	["Silverleaf"] = "銀葉草",
	["Peacebloom"] = "寧神花",
	["Mageroyal"] = "魔皇草",
	["Bruiseweed"] = "跌打草",
	["Kingsblood"] = "皇血草",
	["Fadeleaf"] = "枯葉草",
	["Stranglekelp"] = "荊棘藻",
	["Liferoot"] = "活根草",
	["Briarthorn"] = "石南草",
	["Earthroot"] = "地根草",
	["Sungrass"] = "太陽草",
	["Blindweed"] = "盲目草",
	["Gromsblood"] = "格羅姆之血",
	["Dreamfoil"] = "夢葉草",
	["Firebloom"] = "火焰花",
	["Arthas' Tears"] = "阿薩斯之淚",
	["Purple Lotus"] = "紫蓮花",
	["Goldthorn"] = "金棘草",
	["Wildvine"] = "野葡萄藤",
	["Grave Moss"] = "墓地苔",
	["Mountain Silversage"] = "山鼠草",
	["Black Lotus"] = "黑蓮花",
	["Ghost Mushroom"] = "幽靈菇",
	["Golden Sansam"] = "黃金蔘",
	["Icecap"] = "冰蓋草",
	["Khadgar's Whisker"] = "卡德加的鬍鬚",
	["Plaguebloom"] = "瘟疫花",
	["Swiftthistle"] = "雨燕草",
	["Wild Steelbloom"] = "野鋼花",
	["Wintersbite"] = "冬刺草",
	-- tbc
--	["Felweed"] = true,
--	["Bloodthistle"] = true,
--	["Mana Thistle"] = true,
--	["Netherbloom"] = true,
--	["Nightmare Vine"] = true,
--	["Ragveil"] = true,
--	["Terocone"] = true,
--	["Flame Cap"] = true,
--	["Dreaming Glory"] = true,
--	["Fel Lotus"] = true,
--	["Ancient Lichen"] = true,
} end)

L:RegisterTranslations("esES", function() return {
	["Filter"] = "Filtro",
	["Filter out herbs"] = "Filtra las hierbas",
  
  ["Module description"]  = "Notas de mapa de Herborister\195\173a para Cartographer (basado en PinPoint por Ammo)",
	
	["Select all"] = "Seleccionar todo",
	["Select none"] = "No seleccionar nada",
	["Icon alpha"] = "Transparencia de icono",
	["Alpha transparency of the icon"] = "Transparencia de los iconos",
	["Icon size"] = "Tama\195\177o de icono",
	["Size of the icons on the map"] = "Tama\195\177o de los iconos en el mapa",
        ["Show minimap icons"] = "Mostrar iconos en minimapa",
        ["Show herbalism icons on the minimap"] = "Muestra los iconos de herborister\195\173a en el minimapa",

	-- herbs
	["Silverleaf"] = "Hojaplata",
	["Peacebloom"] = "Flor de paz",
	["Mageroyal"] = "Marregal",
	["Bruiseweed"] = "Hierba cardenal",
	["Kingsblood"] = "Sangrerregia",
	["Fadeleaf"] = "P\195\161lida",
	["Stranglekelp"] = "Alga estranguladora",
	["Liferoot"] = "Vidarra\195\173z",
	["Briarthorn"] = "Brezospina",
	["Earthroot"] = "Ra\195\173z de tierra",
	["Sungrass"] = "Solea",
	["Blindweed"] = "Carolina",
	["Gromsblood"] = "Gromsanguina",
	["Dreamfoil"] = "Hojasue\195\177o",
	["Firebloom"] = "Flor de Fuego",
	["Arthas' Tears"] = "L\195\161grimas de Arthas",
	["Purple Lotus"] = "Loto morado",
	["Goldthorn"] = "Espina de oro",
	["Wildvine"] = "Atriplex salvaje",
	["Grave Moss"] = "Moho de tumba",
	["Mountain Silversage"] = "Salviargenta de monta\195\177a",
	["Black Lotus"] = "Loto negro",
	["Ghost Mushroom"] = "Champi\195\177\195\179n fantasma",
	["Golden Sansam"] = "Sansam dorado",
	["Icecap"] = "Setelo",
	["Khadgar's Whisker"] = "Mostacho de Khadgar",
	["Plaguebloom"] = "Flor de peste",
	["Swiftthistle"] = "Cardoveloz",
	["Wild Steelbloom"] = "Ac\195\169rita salvaje",
	["Wintersbite"] = "Ivernalia",
	-- tbc
	["Felweed"] = "Hierba vil",
	["Dreaming Glory"] = "Gloria de ensue\195\177o",
	["Terocone"] = "Teropi\195\177a",
	["Ancient Lichen"] = "Liquen antiguo",
	["Bloodthistle"] = "Cardo de sangre",
	["Mana Thistle"] = "Cardo de man\195\161",   -- check
	["Netherbloom"] = "Flor abisal",   -- check
	["Nightmare Vine"] = "Nightmare Vine", -- fix
	["Ragveil"] = "Velada",
	["Flame Cap"] = "Gopo de llamas",  -- check
	["Fel Lotus"] = "Loto vil", -- check
} end)

local mod = Cartographer:NewModule("Herbalism", "AceConsole-2.0", "AceEvent-2.0")

mod.icon = {
    ["Black Lotus"] = {
		text = L["Black Lotus"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbBlackLotus.tga",
		width = 12,
		height = 12
	},
	["Blindweed"] = {
		text = L["Blindweed"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbBlindweed.tga",
		width = 12,
		height = 12
	},
	["Briarthorn"] = {
		text = L["Briarthorn"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbBriarthorn.tga",
		width = 12,
		height = 12
	},
	["Bruiseweed"] = {
		text = L["Bruiseweed"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbBruiseweed.tga",
		width = 12,
		height = 12
	},
	["Dreamfoil"] = {
		text = L["Dreamfoil"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbDreamfoil.tga",
		width = 12,
		height = 12
	},
	["Earthroot"] = {
		text = L["Earthroot"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbEarthroot.tga",
		width = 12,
		height = 12
	},
	["Fadeleaf"] = {
		text = L["Fadeleaf"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbFadeleaf.tga",
		width = 12,
		height = 12
	},
	["Felweed"] = {
		text = L["Felweed"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbFelweed.tga",
		width = 12,
		height = 12
	},
	["Firebloom"] = {
		text = L["Firebloom"],
        path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbFirebloom.tga",
		width = 12,
		height = 12
	},
	["Goldthorn"] = {
		text = L["Goldthorn"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbGoldthorn.tga",
		width = 12,
		height = 12
	},
	["Grave Moss"] = {
		text = L["Grave Moss"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbGraveMoss.tga",
		width = 12,
		height = 12
	},
	["Gromsblood"] = {
		text = L["Gromsblood"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbGromsblood.tga",
		width = 12,
		height = 12
	},
	["Icecap"] = {
		text = L["Icecap"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbIcecap.tga",
		width = 12,
		height = 12
	},
	["Kingsblood"] = {
		text = L["Kingsblood"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbKingsblood.tga",
		width = 12,
		height = 12
	},
	["Liferoot"] = {
		text = L["Liferoot"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbLiferoot.tga",
		width = 12,
		height = 12
	},
	["Mageroyal"] = {
		text = L["Mageroyal"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbMageroyal.tga",
		width = 12,
		height = 12
	},
	["Peacebloom"] = {
		text = L["Peacebloom"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbPeacebloom.tga",
		width = 12,
		height = 12
	},
	["Plaguebloom"] = {
		text = L["Plaguebloom"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbPlaguebloom.tga",
		width = 12,
		height = 12
	},
	["Silverleaf"] = {
		text = L["Silverleaf"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbSilverleaf.tga",
		width = 12,
		height = 12
	},
	["Stranglekelp"] = {
		text = L["Stranglekelp"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbStranglekelp.tga",
		width = 12,
		height = 12
	},
	["Sungrass"] = {
		text = L["Sungrass"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbSungrass.tga",
		width = 12,
		height = 12
	},
	["Swiftthistle"] = {
		text = L["Swiftthistle"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbSwiftthistle.tga",
		width = 12,
		height = 12
	},
	["Wildvine"] = {
		text = L["Wildvine"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbKingsblood.tga",
		width = 12,
		height = 12
	},
	["Wintersbite"] = {
		text = L["Wintersbite"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbWintersbite.tga",
		width = 12,
		height = 12
	},
	["Arthas' Tears"] = {
		text = L["Arthas' Tears"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbArthasTears.tga",
		width = 12,
		height = 12
	},
	["Ghost Mushroom"] = {
		text = L["Ghost Mushroom"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbGhostMushroom.tga",
		width = 12,
		height = 12
	},
	["Golden Sansam"] = {
		text = L["Golden Sansam"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbGoldenSansam.tga",
		width = 12,
		height = 12
	},
	["Khadgar's Whisker"] = {
		text = L["Khadgar's Whisker"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbKhadgarsWhisker.tga",
		width = 12,
		height = 12
	},
	["Mountain Silversage"] = {
		text = L["Mountain Silversage"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbMountainSilversage.tga",
		width = 12,
		height = 12
	},
	["Purple Lotus"] = {
		text = L["Purple Lotus"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbPurpleLotus.tga",
		width = 12,
		height = 12
	},
	["Wild Steelbloom"] = {
		text = L["Wild Steelbloom"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbWildSteelbloom.tga",
		width = 12,
		height = 12
	},
	["Bloodthistle"] = {
		text = L["Bloodthistle"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbGromsblood.tga",
		width = 12,
		height = 12
	},
	["Mana Thistle"] = {
		text = L["Mana Thistle"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbManaThistle.tga",
		width = 12,
		height = 12
	},
	["Netherbloom"] = {
		text = L["Netherbloom"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbNetherbloom.tga",
		width = 12,
		height = 12
	},
	["Nightmare Vine"] = {
		text = L["Nightmare Vine"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbNightmareVine.tga",
		width = 12,
		height = 12
	},
	["Ragveil"] = {
		text = L["Ragveil"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbRagveil.tga",
		width = 12,
		height = 12
	},
	["Terocone"] = {
		text = L["Terocone"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbTerocone.tga",
		width = 12,
		height = 12
	},
	["Flame Cap"] = {
		text = L["Flame Cap"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbFlameCap.tga",
		width = 12,
		height = 12
	},
	["Dreaming Glory"] = {
		text = L["Dreaming Glory"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbDreamingGlory.tga",
		width = 12,
		height = 12
	},
	["Fel Lotus"] = {
		text = L["Fel Lotus"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbFelLotus.tga",
		width = 12,
		height = 12
	},
   	["Ancient Lichen"] = {
		text = L["Ancient Lichen"],
		path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\HerbAncientLichen.tga",
		width = 12,
		height = 12
	},
}

function mod:OnInitialize()
	self.db = Cartographer:AcquireDBNamespace("Herbalism")
	Cartographer:RegisterDefaults("Herbalism", "profile", {
		filter = {
			['*'] = true,
		},
		iconAlpha = 1,
		iconScale = 1,
		minicons = true,
		
	})
	
	local aceopts = {}
	aceopts.trans = {
		name = L["Icon alpha"],
		desc = L["Alpha transparency of the icon"],
		type = 'range',
		min = 0.1,
		max = 1,
		step = 0.05,
		isPercent = true,
		get = "GetIconAlpha",
		set = "SetIconAlpha",
		order = 1
	}
	aceopts.scal = {
		name = L["Icon size"],
		desc = L["Size of the icons on the map"],
		type = 'range',
		min = 0.5,
		max = 2,
		step = 0.05,
		isPercent = true,
		get = "GetIconScale",
		set = "SetIconScale",
		order = 1
	}
	aceopts.minicons = {
		name = L["Show minimap icons"],
		desc = L["Show herbalism icons on the minimap"],
		type = 'toggle',
		set = "ToggleShowingMinimapIcons",
		get = "IsShowingMinimapIcons",
		order = 1,
	}
	aceopts.toggle = {
		name = AceLibrary("AceLocale-2.2"):new("Cartographer")["Enabled"],
		desc = AceLibrary("AceLocale-2.2"):new("Cartographer")["Suspend/resume this module."],
		type  = 'toggle',
		order = -1,
		get   = function() return Cartographer:IsModuleActive(self) end,
		set   = function() Cartographer:ToggleModuleActive(self) end,
	}
	aceopts.filter = {
		name = L["Filter"],
		desc = L["Filter out herbs"],
		type = 'group',
		args = {
			all = {
				name = L["Select all"],
				desc = L["Select all"],
				type = 'execute',
				func = function()
					for k in pairs(self.icon) do
						self:ToggleShowingHerb(k, true)
					end
				end,
				order = 1,
			},
			none = {
				name = L["Select none"],
				desc = L["Select none"],
				type = 'execute',
				func = function()
					for k in pairs(self.icon) do
						self:ToggleShowingHerb(k, false)
					end
				end,
				order = 2,
			},
			blank = {
				type = 'header',
				order = 3,
			}
		}
	}
	for k,v in pairs(self.icon) do
		local k = k
		aceopts.filter.args[k] = {
			name = v.text,
			desc = v.text,
			type = 'toggle',
			get = function()
				return self:IsShowingHerb(k)
			end,
			set = function(value)
				return self:ToggleShowingHerb(k, value)
			end,
		}
	end
	
	Cartographer.options.args["Herbalism"] = {
		name = bs["Herbalism"],
		desc = L["Module description"],
		type = 'group',
		args = aceopts,
		handler = self,
	}
	AceLibrary("AceConsole-2.0"):InjectAceOptionsTable(self, Cartographer.options.args["Herbalism"])
	Cartographer:GetModule('Professions').addons[bs["Herbalism"]] = self
	
	if not Cartographer_HerbalismDB then
		Cartographer_HerbalismDB = {}
	end
end

function mod:OnEnable()
	if Cartographer_Notes then
		if not self.iconsregistered then
			for k,v in pairs(self.icon) do
				Cartographer_Notes:RegisterIcon(k, v)
			end
			self.iconsregistered = true
		end
		
		Cartographer_Notes:RegisterNotesDatabase('Herbalism', Cartographer_HerbalismDB, self)
	else
		Cartographer:ToggleModuleActive(self, false)
	end
	Talismonger:TrackNode(L["Silverleaf"])
	Talismonger:TrackNode(L["Peacebloom"])
	Talismonger:TrackNode(L["Mageroyal"])
	Talismonger:TrackNode(L["Bruiseweed"])
	Talismonger:TrackNode(L["Kingsblood"])
	Talismonger:TrackNode(L["Fadeleaf"])
	Talismonger:TrackNode(L["Stranglekelp"])
	Talismonger:TrackNode(L["Liferoot"])
	Talismonger:TrackNode(L["Briarthorn"])
	Talismonger:TrackNode(L["Earthroot"])
	Talismonger:TrackNode(L["Sungrass"])
	Talismonger:TrackNode(L["Blindweed"])
	Talismonger:TrackNode(L["Gromsblood"])
	Talismonger:TrackNode(L["Dreamfoil"])
	Talismonger:TrackNode(L["Firebloom"])
	Talismonger:TrackNode(L["Arthas' Tears"])
	Talismonger:TrackNode(L["Purple Lotus"])
	Talismonger:TrackNode(L["Goldthorn"])
	Talismonger:TrackNode(L["Wildvine"])
	Talismonger:TrackNode(L["Grave Moss"])
	Talismonger:TrackNode(L["Mountain Silversage"])
	Talismonger:TrackNode(L["Black Lotus"])
	Talismonger:TrackNode(L["Ghost Mushroom"])
	Talismonger:TrackNode(L["Golden Sansam"])
	Talismonger:TrackNode(L["Icecap"])
	Talismonger:TrackNode(L["Khadgar's Whisker"])
	Talismonger:TrackNode(L["Plaguebloom"])
	Talismonger:TrackNode(L["Swiftthistle"])
	Talismonger:TrackNode(L["Wild Steelbloom"])
	Talismonger:TrackNode(L["Wintersbite"])
	Talismonger:TrackNode(L["Felweed"])
	Talismonger:TrackNode(L["Bloodthistle"])
	Talismonger:TrackNode(L["Mana Thistle"])
	Talismonger:TrackNode(L["Netherbloom"])
	Talismonger:TrackNode(L["Nightmare Vine"])
	Talismonger:TrackNode(L["Ragveil"])
	Talismonger:TrackNode(L["Terocone"])
	Talismonger:TrackNode(L["Flame Cap"])
	Talismonger:TrackNode(L["Dreaming Glory"])
	Talismonger:TrackNode(L["Fel Lotus"])
	Talismonger:TrackNode(L["Ancient Lichen"])
	self:RegisterEvent("Talismonger_Node")
	--self:RegisterEvent("UI_ERROR_MESSAGE")
	--self:RegisterEvent("CHAT_MSG_SPELL_SELF_BUFF")
end

function mod:Talismonger_Node(spell, what)
	if spell == "Herb Gathering" then
		self:SetNote(what)
	end
end

function mod:OnDisable()
	self:UnregisterAllEvents()
	
	if Cartographer_Notes then
		Cartographer_Notes:UnregisterNotesDatabase('Herbalism')
	end
end

function mod:SetNote(what)
	local x, y = GetPlayerMapPosition("player")
	if x == 0 and y == 0 then return end
	local zone = GetRealZoneText()
	what = what:gsub("^(.-) %(%d+%)$", "%1")
	what = L:GetReverseTranslation(what)
	for zone, x_p, y_p, icon, creator, data in Cartographer_Notes:IterateNearbyNotes(zone, x, y, 8, "Herbalism", nil, true) do
		if icon == what then
			Cartographer_Notes:DeleteNote(zone, x_p, y_p)
		end
	end
	Cartographer_Notes:SetNote(zone, x, y, what, "Herbalism")
end

function mod:OnNoteTooltipRequest(zone, id, herb, minimap)
	Tablet:SetTitle(L[herb])
	Tablet:SetTitleColor(0, 0.8, 0)
	
	if Cartographer_Notes:IsShowingCreator() and not minimap then
		Tablet:AddCategory(
			'columns', 2,
			'hideBlankLine', true
		):AddLine(
			'text', AceLibrary("AceLocale-2.2"):new("Cartographer-Notes")["Created by"],
			'text2', bs["Herbalism"]
		)
	end
end

--local perform_string = '^' .. SIMPLEPERFORMSELFOTHER:format(bs["Herb Gathering"], "%s"):gsub("([%(%)%.%*%+%-%[%]%?%^%$%%])", "%%%1"):gsub("%%%%s", "(.+)") .. '$'
--function mod:CHAT_MSG_SPELL_SELF_BUFF(msg)
--	local what = msg:match(perform_string)
--	if what then
--		self:SetNote(what)
--	end
--end

--function mod:UI_ERROR_MESSAGE(msg)
--	if msg:find(UNIT_SKINNABLE_HERB) then
--		local what = GameTooltipTextLeft1:GetText()
--		if what and what:len() > 0 then
--			self:SetNote(what)
--		end
--	end
--end

function mod:IsNoteHidden(zone, id, herb)
	return not self.db.profile.filter[herb]
end

function mod:IsShowingHerb(herb)
	return self.db.profile.filter[herb]
end

function mod:ToggleShowingHerb(herb, value)
	if value == nil then
		value = not self.db.profile.filter[herb]
	end
	self.db.profile.filter[herb] = value
	self:ScheduleEvent("CartographerHerbalism_RefreshMap", Cartographer_Notes.RefreshMap, 0, Cartographer_Notes)
end

function mod:GetIconScale()
	return self.db.profile.iconScale
end

function mod:SetIconScale(value)
	self.db.profile.iconScale = value
	self:ScheduleEvent("CartographerHerbalism_RefreshMap", Cartographer_Notes.RefreshMap, 0, Cartographer_Notes)
end
function mod:GetIconAlpha()
	return self.db.profile.iconAlpha
end

function mod:SetIconAlpha(value)
	self.db.profile.iconAlpha = value
	self:ScheduleEvent("CartographerHerbalism_RefreshMap", Cartographer_Notes.RefreshMap, 0, Cartographer_Notes)
end

function mod:GetNoteTransparency(zone,id,data)
	return self.db.profile.iconAlpha
end
function mod:GetNoteScaling(zone,id,data)
	return self.db.profile.iconScale
end
function mod:IsShowingMinimapIcons()
	return self.db.profile.minicons
end
function mod:ToggleShowingMinimapIcons()
	self.db.profile.minicons = not self.db.profile.minicons
end
function mod:IsMiniNoteHidden(zone,id,data)
	return not self.db.profile.minicons
end
